Index: /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crs.F90
===================================================================
--- /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crs.F90	(revision 5104)
+++ /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crs.F90	(revision 5105)
@@ -94,6 +94,6 @@
  
       ! Masks
-      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: tmask_crs, umask_crs, vmask_crs, fmask_crs
-      REAL(wp), DIMENSION(:,:)  , ALLOCATABLE :: tmask_i_crs, rnfmsk_crs, tpol_crs, fpol_crs
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE,SAVE :: tmask_crs, umask_crs, vmask_crs, fmask_crs
+      REAL(wp), DIMENSION(:,:)  , ALLOCATABLE,SAVE :: tmask_i_crs, rnfmsk_crs, tpol_crs, fpol_crs
       
   !    REAL(wp), DIMENSION(:,:),   ALLOCATABLE :: tmask_i_crs, tpol, fpol      
@@ -112,9 +112,9 @@
                                                                   ! vertical scale factors 
       ! Coordinates
-      REAL(wp), DIMENSION(:,:),   ALLOCATABLE :: gphit_crs, glamt_crs, gphif_crs, glamf_crs 
-      REAL(wp), DIMENSION(:,:),   ALLOCATABLE :: gphiu_crs, glamu_crs, gphiv_crs, glamv_crs 
-      REAL(wp), DIMENSION(:,:),   ALLOCATABLE :: ff_crs
-      INTEGER,  DIMENSION(:,:),   ALLOCATABLE :: mbathy_crs, mbkt_crs, mbku_crs, mbkv_crs
-      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE :: gdept_crs, gdepu_crs, gdepv_crs, gdepw_crs
+      REAL(wp), DIMENSION(:,:),   ALLOCATABLE,SAVE :: gphit_crs, glamt_crs, gphif_crs, glamf_crs 
+      REAL(wp), DIMENSION(:,:),   ALLOCATABLE,SAVE :: gphiu_crs, glamu_crs, gphiv_crs, glamv_crs 
+      REAL(wp), DIMENSION(:,:),   ALLOCATABLE,SAVE :: ff_crs
+      INTEGER,  DIMENSION(:,:),   ALLOCATABLE,SAVE :: mbathy_crs, mbkt_crs, mbku_crs, mbkv_crs
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE,SAVE :: gdept_crs, gdepu_crs, gdepv_crs, gdepw_crs
 
       ! Weights
@@ -136,4 +136,5 @@
       INTEGER           :: nn_crs_kz    =    0       !: type of Kz coarsening ( =0->VOL ; =1->MAX ; =2->MIN) 
       LOGICAL           :: ln_crs_wn    = .FALSE.    !: coarsening wn or computation using horizontal divergence 
+      LOGICAL, PUBLIC   :: ln_crs_top = .FALSE.          !:coarsening online for the bio
       !
       INTEGER           :: nrestx, nresty       !: for determining odd or even reduction factor
@@ -146,12 +147,17 @@
 
       ! Physical and dynamical ocean fields for output or passing to TOP, time-mean fields
-      REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE      :: tsn_crs
+      REAL(wp), DIMENSION(:,:,:,:), ALLOCATABLE      :: tsb_crs,tsn_crs
       REAL(wp), DIMENSION(:,:,:)  , ALLOCATABLE      :: un_crs, vn_crs, wn_crs, rke_crs
-      REAL(wp), DIMENSION(:,:,:)  , ALLOCATABLE      :: hdivn_crs    
-      REAL(wp), DIMENSION(:,:)    , ALLOCATABLE      :: sshn_crs    
+      REAL(wp), DIMENSION(:,:,:)  , ALLOCATABLE      :: ub_crs, vb_crs
+      REAL(wp), DIMENSION(:,:,:)  , ALLOCATABLE      :: hdivb_crs , hdivn_crs    
+      REAL(wp), DIMENSION(:,:)    , ALLOCATABLE      :: sshb_crs, sshn_crs , ssha_crs
+      REAL(wp), DIMENSION(:,:,:)  , ALLOCATABLE      :: rhop_crs,rhd_crs,rb2_crs
+      REAL(wp), DIMENSION(:,:)    , ALLOCATABLE      :: gru_crs, grv_crs
+      REAL(wp), DIMENSION(:,:,:)  , ALLOCATABLE      :: gtsu_crs, gtsv_crs
       ! 
       ! Surface fluxes to pass to TOP
       REAL(wp), PUBLIC, DIMENSION(:,:)  , ALLOCATABLE :: qsr_crs, fr_i_crs, wndm_crs
       REAL(wp), PUBLIC, DIMENSION(:,:)  , ALLOCATABLE :: emp_crs, emp_b_crs, sfx_crs
+      REAL(wp), PUBLIC, DIMENSION(:,:)  , ALLOCATABLE :: fmmflx_crs
       REAL(wp), PUBLIC, DIMENSION(:,:)  , ALLOCATABLE :: utau_crs, vtau_crs
       REAL(wp), PUBLIC, DIMENSION(:,:)  , ALLOCATABLE :: rnf_crs
@@ -164,5 +170,6 @@
 
       ! Mixing and Mixed Layer Depth
-      INTEGER,  PUBLIC, ALLOCATABLE, DIMENSION(:,:)    ::  nmln_crs, hmld_crs, hmlp_crs, hmlpt_crs                       
+      INTEGER,  PUBLIC, DIMENSION(:,:) , ALLOCATABLE ::  nmln_crs
+      REAL(wp), PUBLIC, DIMENSION(:,:) , ALLOCATABLE :: hmlp_crs , hmlpt_crs , hmld_crs
 
       ! Direction of lateral diffusion
@@ -235,14 +242,19 @@
 
 
-      ALLOCATE( un_crs(jpi_crs,jpj_crs,jpk) , vn_crs(jpi_crs,jpj_crs,jpk) , &
-         &      wn_crs(jpi_crs,jpj_crs,jpk) , hdivn_crs(jpi_crs,jpj_crs,jpk),&
-         &      rke_crs(jpi_crs,jpj_crs,jpk),                                STAT=ierr(11))
-
-     ALLOCATE( sshn_crs(jpi_crs,jpj_crs), emp_crs (jpi_crs,jpj_crs), emp_b_crs(jpi_crs,jpj_crs), &
+      ALLOCATE( ub_crs(jpi_crs,jpj_crs,jpk) , vb_crs(jpi_crs,jpj_crs,jpk) , &
+         &      un_crs(jpi_crs,jpj_crs,jpk) , vn_crs(jpi_crs,jpj_crs,jpk)    ,  wn_crs(jpi_crs,jpj_crs,jpk) , &
+         &      hdivb_crs(jpi_crs,jpj_crs,jpk) , hdivn_crs(jpi_crs,jpj_crs,jpk) , &
+         &      rke_crs(jpi_crs,jpj_crs,jpk), rhop_crs(jpi_crs,jpj_crs,jpk)  , &
+         &      rb2_crs(jpi_crs,jpj_crs,jpk) ,rhd_crs(jpi_crs,jpj_crs,jpk)   , &
+         &      gtsu_crs(jpi_crs,jpj_crs,jpk) ,gtsv_crs(jpi_crs,jpj_crs,jpk) , &
+                gru_crs(jpi_crs,jpj_crs) ,grv_crs(jpi_crs,jpj_crs) , STAT=ierr(11))
+
+     ALLOCATE( sshb_crs(jpi_crs,jpj_crs), sshn_crs(jpi_crs,jpj_crs),  ssha_crs(jpi_crs,jpj_crs), &
+         &     emp_crs (jpi_crs,jpj_crs), emp_b_crs(jpi_crs,jpj_crs), &
          &     qsr_crs(jpi_crs ,jpj_crs), wndm_crs(jpi_crs,jpj_crs), utau_crs(jpi_crs,jpj_crs) , &
          &     vtau_crs(jpi_crs,jpj_crs), rnf_crs(jpi_crs ,jpj_crs), &
-         &     fr_i_crs(jpi_crs,jpj_crs), sfx_crs(jpi_crs ,jpj_crs),  STAT=ierr(12)  )
-
-     ALLOCATE( tsn_crs(jpi_crs,jpj_crs,jpk,jpts), avt_crs(jpi_crs,jpj_crs,jpk),    &
+         &     fr_i_crs(jpi_crs,jpj_crs), sfx_crs(jpi_crs ,jpj_crs), fmmflx_crs(jpi_crs ,jpj_crs),  STAT=ierr(12)  )
+
+     ALLOCATE( tsn_crs(jpi_crs,jpj_crs,jpk,jpts), tsb_crs(jpi_crs,jpj_crs,jpk,jpts), avt_crs(jpi_crs,jpj_crs,jpk),    &
 # if defined key_zdfddm
          &      avs_crs(jpi_crs,jpj_crs,jpk),    &
@@ -302,5 +314,4 @@
       !! ** Purpose : +Return back to parent grid domain 
       !!---------------------------------------------------------------------
-      write(narea+200,*)"dom_grid_glo";call flush(narea+200)
 
       !                         Return to parent grid domain
@@ -346,5 +357,4 @@
       !! ** Purpose :  Save the parent grid information & Switch to coarse grid domain
       !!---------------------------------------------------------------------
-      write(narea+200,*)"dom_grid_crs";call flush(narea+200)
       !
       !                        Switch to coarse grid domain
Index: /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90
===================================================================
--- /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 5104)
+++ /branches/2015/dev_r5003_MERCATOR6_CRS/NEMOGCM/NEMO/OPA_SRC/CRS/crsdom.F90	(revision 5105)
@@ -52,5 +52,5 @@
    END INTERFACE
 
-   REAL(wp) :: r_inf = 1e+36
+   REAL(wp),PUBLIC :: r_inf = 1e+7 !cbr 1e+36
 
    !! Substitutions
@@ -64,4 +64,5 @@
       INTEGER  ::  ji, jj, jk                   ! dummy loop indices
       INTEGER  ::  ijie,ijis,ijje,ijjs,ij,je_2
+      INTEGER  ::  iji, ijj
       REAL(wp) ::  zmask
       
@@ -122,5 +123,12 @@
                ijjs = mjs_crs(jj)
 
-               IF( ijje .GT. jpj )WRITE(narea+200,*)"BUG",jj,ijjs,ijje,SHAPE(tmask) ; call flush(narea+200)
+               !iji=117 ; ijj=211
+               !iji=iji-nimpp_crs+1 ; ijj=ijj-njmpp_crs+1
+               !IF( ji ==iji .AND. jj==ijj .AND. jk==74 )THEN
+               !write(narea+5000,*)"mask ",ji,jj
+               !write(narea+5000,*)"mask ",ijie,ijis,ijjs,ijje
+               !ENDIF
+
+               !IF( ijje .GT. jpj )WRITE(narea+200,*)"BUG",jj,ijjs,ijje,SHAPE(tmask) ; call flush(narea+200)
                zmask = 0.0
                zmask = SUM( tmask(ijis:ijie,ijjs:ijje,jk) )
@@ -140,9 +148,35 @@
          ENDDO
       ENDDO
+      CALL crs_lbc_lnk( tmask_crs, 'T', 1.0 )
+      !cbr
+      !DO ji=1,jpi_crs-1
+      !DO jj=1,jpj_crs-1
+      !DO jk=1,jpk
+      !   umask_crs(ji,jj,jk) = tmask_crs(ji  ,jj  ,jk) * tmask_crs(ji+1,jj  ,jk)
+      !   vmask_crs(ji,jj,jk) = tmask_crs(ji  ,jj  ,jk) * tmask_crs(ji  ,jj+1,jk)
+      !   fmask_crs(ji,jj,jk) = tmask_crs(ji  ,jj  ,jk) * tmask_crs(ji  ,jj+1,jk) *  tmask_crs(ji+1,jj  ,jk) *   tmask_crs(ji+1,jj+1,jk) 
+      !ENDDO
+      !ENDDO
+      !ENDDO
       !
-      CALL crs_lbc_lnk( tmask_crs, 'T', 1.0 )
       CALL crs_lbc_lnk( vmask_crs, 'V', 1.0 )
       CALL crs_lbc_lnk( umask_crs, 'U', 1.0 )
       CALL crs_lbc_lnk( fmask_crs, 'F', 1.0 )
+      !
+      !cbr
+      !DO ji=2,jpi_crs-1
+      !DO jj=2,jpj_crs-1
+      !DO jk=1,jpk
+      !   IF( tmask(ji-1,jj  ,jk)==1. .AND. tmask(ji  ,jj  ,jk)==1. .AND. umask(ji-1,jj  ,jk)==0. )WRITE(narea+5000,*)"MASK1",ji,jj,jk
+      !   IF( tmask(ji  ,jj  ,jk)==1. .AND. tmask(ji+1,jj  ,jk)==1. .AND. umask(ji  ,jj  ,jk)==0. )WRITE(narea+5000,*)"MASK2",ji,jj,jk
+      !   IF( tmask(ji  ,jj-1,jk)==1. .AND. tmask(ji  ,jj  ,jk)==1. .AND. vmask(ji  ,jj-1,jk)==0. )WRITE(narea+5000,*)"MASK3",ji,jj,jk
+      !   IF( tmask(ji  ,jj  ,jk)==1. .AND. tmask(ji  ,jj+1,jk)==1. .AND. vmask(ji  ,jj  ,jk)==0. )WRITE(narea+5000,*)"MASK4",ji,jj,jk
+      !   IF( umask(ji-1,jj  ,jk)==1. .AND. ( tmask(ji-1,jj  ,jk)==0. .OR. tmask(ji  ,jj  ,jk)==0. ) )WRITE(narea+5000,*)"MASK5",ji,jj,jk
+      !   IF( umask(ji  ,jj  ,jk)==1. .AND. ( tmask(ji  ,jj  ,jk)==0. .OR. tmask(ji+1,jj  ,jk)==0. ) )WRITE(narea+5000,*)"MASK6",ji,jj,jk
+      !   IF( vmask(ji  ,jj-1,jk)==1. .AND. ( tmask(ji  ,jj-1,jk)==0. .OR. tmask(ji  ,jj  ,jk)==0. ) )WRITE(narea+5000,*)"MASK7",ji,jj,jk
+      !   IF( vmask(ji  ,jj  ,jk)==1. .AND. ( tmask(ji  ,jj  ,jk)==0. .OR. tmask(ji  ,jj+1,jk)==0. ) )WRITE(narea+5000,*)"MASK8",ji,jj,jk
+      !ENDDO
+      !ENDDO
+      !ENDDO
       !
    END SUBROUTINE crs_dom_msk
@@ -385,14 +419,14 @@
 
       zmask(:,:,:) = 0.0
-      IF( cd_type == 'W' ) THEN
-         zmask(:,:,1) = p_mask(:,:,1) 
-         DO jk = 2, jpk
-            zmask(:,:,jk) = p_mask(:,:,jk-1) 
-         ENDDO
-      ELSE
+      !IF( cd_type == 'W' ) THEN
+      !   zmask(:,:,1) = p_mask(:,:,1) 
+      !   DO jk = 2, jpk
+      !      zmask(:,:,jk) = p_mask(:,:,jk-1) 
+      !   ENDDO
+      !ELSE
          DO jk = 1, jpk
              zmask(:,:,jk) = p_mask(:,:,jk) 
          ENDDO
-      ENDIF
+      !ENDIF
 
       IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
@@ -513,4 +547,5 @@
       REAL(wp) :: zflcrs, zsfcrs   
       REAL(wp), DIMENSION(:,:,:), POINTER :: zsurf, zsurfmsk, zmask  
+      INTEGER  :: iji, ijj
       !!----------------------------------------------------------------  
    
@@ -526,17 +561,18 @@
             
                CASE( 'T', 'W' )
-                  IF( cd_type == 'T' ) THEN
+                  !IF( cd_type == 'T' ) THEN
                      DO jk = 1, jpk
                         zsurf   (:,:,jk) =  p_e12(:,:) * p_e3(:,:,jk) *  p_mask(:,:,jk) 
                         zsurfmsk(:,:,jk) =  zsurf(:,:,jk) 
                     ENDDO
-                  ELSE
-                     zsurf   (:,:,1) =  p_e12(:,:) * p_e3(:,:,1)
-                     zsurfmsk(:,:,1) =  zsurf(:,:,1) *  p_mask(:,:,1) 
-                     DO jk = 2, jpk
-                        zsurf   (:,:,jk) =  p_e12(:,:) * p_e3(:,:,jk)
-                        zsurfmsk(:,:,jk) =  zsurf(:,:,jk) * p_mask(:,:,jk-1) 
-                     ENDDO
-                  ENDIF
+                  !ELSE
+                  !  !cbr ????????????????????????????????
+                  !   zsurf   (:,:,1) =  p_e12(:,:) * p_e3(:,:,1)
+                  !   zsurfmsk(:,:,1) =  zsurf(:,:,1) *  p_mask(:,:,1) 
+                  !   DO jk = 2, jpk
+                  !      zsurf   (:,:,jk) =  p_e12(:,:) * p_e3(:,:,jk)
+                  !      zsurfmsk(:,:,jk) =  zsurf(:,:,jk) * p_mask(:,:,jk-1) 
+                  !   ENDDO
+                  !ENDIF
          
                   IF( nldj_crs == 1 .AND. ( ( mje_crs(2) - mjs_crs(2) ) < 2 ) ) THEN     !!cc bande du sud style ORCA2
@@ -619,12 +655,19 @@
               CASE( 'W' )
                   IF( PRESENT( p_e3 ) ) THEN
-                    zsurfmsk(:,:,1) =  p_e12(:,:) * p_e3(:,:,1) * p_mask(:,:,1) 
-                    DO jk = 2, jpk
-                      zsurfmsk(:,:,jk) =  p_e12(:,:) * p_e3(:,:,jk) * p_mask(:,:,jk-1) 
+                    !cbr ?????????????
+                    !zsurfmsk(:,:,1) =  p_e12(:,:) * p_e3(:,:,1) * p_mask(:,:,1) 
+                    !DO jk = 2, jpk
+                    !  zsurfmsk(:,:,jk) =  p_e12(:,:) * p_e3(:,:,jk) * p_mask(:,:,jk-1) 
+                    !ENDDO
+                    DO jk = 1, jpk
+                      zsurfmsk(:,:,jk) =  p_e12(:,:) * p_e3(:,:,jk) * p_mask(:,:,jk) 
                     ENDDO
                  ELSE
-                    zsurfmsk(:,:,1) =  p_e12(:,:) * p_mask(:,:,1) 
-                    DO jk = 2, jpk
-                      zsurfmsk(:,:,jk) =  p_e12(:,:) * p_mask(:,:,jk-1) 
+                    !zsurfmsk(:,:,1) =  p_e12(:,:) * p_mask(:,:,1) 
+                    !DO jk = 2, jpk
+                    !  zsurfmsk(:,:,jk) =  p_e12(:,:) * p_mask(:,:,jk-1) 
+                    !ENDDO
+                    DO jk = 1, jpk
+                      zsurfmsk(:,:,jk) =  p_e12(:,:) * p_mask(:,:,jk) 
                     ENDDO
                  ENDIF
@@ -712,11 +755,11 @@
                                &      + p_fld(ji+2,jj  ,jk) * zsurfmsk(ji+2,jj  ,jk)
 
-                              zsfcrs = zsurfmsk(ji  ,jj  ,jk) &
-                               &     + zsurfmsk(ji+1,jj  ,jk) &
-                               &     + zsurfmsk(ji+2,jj  ,jk)
-
-                              IF( zsfcrs == 0 ) THEN  ; p_fld_crs(ii,2,jk) = zflcrs
-                              ELSE                    ; p_fld_crs(ii,2,jk) = zflcrs / zsfcrs
-                              ENDIF
+                              !zsfcrs = zsurfmsk(ji  ,jj  ,jk) &
+                              ! &     + zsurfmsk(ji+1,jj  ,jk) &
+                              ! &     + zsurfmsk(ji+2,jj  ,jk)
+
+                              !IF( zsfcrs == 0 ) THEN  ; p_fld_crs(ii,2,jk) = zflcrs
+                              !ELSE                    ; p_fld_crs(ii,2,jk) = zflcrs / zsfcrs
+                              !ENDIF
                            ENDIF
                         ELSE
@@ -726,11 +769,12 @@
                              &      + p_fld(ji+2,ijje,jk) * zsurfmsk(ji+2,ijje,jk)
                            !
-                           zsfcrs =  zsurfmsk(ji  ,ijje,jk) &
-                             &     + zsurfmsk(ji+1,ijje,jk) &
-                             &     + zsurfmsk(ji+2,ijje,jk)
-
-                           IF( zsfcrs == 0 ) THEN ; p_fld_crs(ii,2,jk) = zflcrs
-                           ELSE                   ; p_fld_crs(ii,2,jk) = zflcrs / zsfcrs
-                           ENDIF
+                           !zsfcrs =  zsurfmsk(ji  ,ijje,jk) &
+                           !  &     + zsurfmsk(ji+1,ijje,jk) &
+                           !  &     + zsurfmsk(ji+2,ijje,jk)
+
+                           p_fld_crs(ii,2,jk) = zflcrs
+                           !IF( zsfcrs == 0 ) THEN ; p_fld_crs(ii,2,jk) = zflcrs
+                           !ELSE                   ; p_fld_crs(ii,2,jk) = zflcrs / zsfcrs
+                           !ENDIF
 
                         ENDIF
@@ -746,12 +790,27 @@
                              &      + p_fld(ji+2,ijje,jk) * zsurfmsk(ji+2,ijje,jk) 
                            !
-                           zsfcrs =  zsurfmsk(ji  ,ijje,jk)  &
-                             &     + zsurfmsk(ji+1,ijje,jk)  &
-                             &     + zsurfmsk(ji+2,ijje,jk) 
-
-                           IF( zsfcrs == 0 ) THEN ; p_fld_crs(ii,ij,jk) = zflcrs
-                           ELSE                   ; p_fld_crs(ii,ij,jk) = zflcrs / zsfcrs
-                           ENDIF
+                           !zsfcrs =  zsurfmsk(ji  ,ijje,jk)  &
+                           !  &     + zsurfmsk(ji+1,ijje,jk)  &
+                           !  &     + zsurfmsk(ji+2,ijje,jk) 
+
+                           p_fld_crs(ii,ij,jk) = zflcrs
+                           !cbr1
+               !iji=117 ; ijj=210
+               !iji=iji-nimpp_crs+1 ; ijj=ijj-njmpp_crs+1
+               !IF( ii==iji .AND. ij==ijj .AND. jk==74 )THEN
+               !WRITE(narea+5000,*)"OPE V =======> "
+               !WRITE(narea+5000,*)ii,ij,jk
+               !WRITE(narea+5000,*)ji,jj,ijje
+               !WRITE(narea+5000,*)p_fld(ji  ,ijje,jk)
+               !WRITE(narea+5000,*)p_fld(ji+1,ijje,jk)
+               !WRITE(narea+5000,*)p_fld(ji+2,ijje,jk)
+               !WRITE(narea+5000,*)zflcrs
+               !ENDIF
+
+                           !IF( zsfcrs == 0 ) THEN ; p_fld_crs(ii,ij,jk) = zflcrs
+                           !ELSE                   ; p_fld_crs(ii,ij,jk) = zflcrs / zsfcrs
+                           !ENDIF
                            !
+               !IF( ii==iji .AND. ij==ijj .AND. jk==74 )WRITE(narea+5000,*)" p_fld_crs(ii,ij,jk) = ", p_fld_crs(ii,ij,jk)
                         ENDDO
                      ENDDO
@@ -809,4 +868,5 @@
               ENDIF
 
+         !IF(narea==267)WRITE(5000+narea,*)"vn_crs(17,5,74) end SUM = ",p_fld(17,5,74)
               CALL wrk_dealloc( jpi, jpj, jpk, zsurfmsk )
 
@@ -987,15 +1047,16 @@
             CALL wrk_alloc( jpi, jpj, jpk, zmask )
 
-            SELECT CASE ( cd_type )
-              CASE( 'W' )
-                  zmask(:,:,1) = p_mask(:,:,1) 
-                  DO jk = 2, jpk
-                     zmask(:,:,jk) = p_mask(:,:,jk-1) 
-                  ENDDO
-              CASE ( 'T' )
+            !SELECT CASE ( cd_type )
+            !  CASE( 'W' )
+            !      !cbr ?????????????????????????????
+            !      zmask(:,:,1) = p_mask(:,:,1) 
+            !      DO jk = 2, jpk
+            !         zmask(:,:,jk) = p_mask(:,:,jk-1) 
+            !      ENDDO
+            !  CASE ( 'T' )
                   DO jk = 1, jpk
                      zmask(:,:,jk) = p_mask(:,:,jk) 
                   ENDDO
-            END SELECT
+            !END SELECT
 
             SELECT CASE ( cd_type )
@@ -1157,5 +1218,7 @@
          END SELECT
          !
+         !IF(narea==267)WRITE(5000+narea,*)"vn_crs(17,5,74) avt lbc = ",p_fld(17,5,74)
          CALL crs_lbc_lnk( p_fld_crs, cd_type, psgn )
+         !IF(narea==267)WRITE(5000+narea,*)"vn_crs(17,5,74) apr lbc = ",p_fld(17,5,74)
          !
     END SUBROUTINE crs_dom_ope_3d
@@ -1205,5 +1268,5 @@
 
       !!----------------------------------------------------------------  
-   
+ 
       p_fld_crs(:,:) = 0.0
 
@@ -1702,5 +1765,5 @@
       INTEGER ::  ijie, ijje, ii, ij, je_2
       REAL(wp) :: ze3crs  
-      REAL(wp), DIMENSION(:,:,:), POINTER :: zmask, zsurf   
+      !REAL(wp), DIMENSION(:,:,:), POINTER :: zmask, zsurf   
 
       !!----------------------------------------------------------------  
